lab8/myimgur/images/urls.py
from unicodedata import name
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
    path('', views.index, name="index"),
    path('<int:image_id>/', views.detail, name="detail"),
    path("new/", views.create_image, name="create_image"),
    path('<int:image_id>/comments/new/', views.post_comment, name="post_comment"),
    path('<int:image_id>/likes/new/', views.like, name="like"),
]

lab8/myimgur/myimgur/urls.py
from django.contrib import admin
from django.urls import path, include

from images import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('images/', include('images.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

lab8/myimgur/images/models.py
from email.mime import image
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Image(models.Model):
    url = models.CharField(max_length=256, blank=False)
    title = models.CharField(max_length=128, blank=False)
    pub_date = models.DateTimeField('Published at')
    def __str__(self):
        return f"{self.id}-{self.title[:20]}"

    def liked_by(self, user):
        try:
            return self.like_set.filter(user.user).count() > 0
        except:
            return False
    
    def toggle_like(self, user):
        if  self.liked_by(user):
            like = self.like_set.filter(user.user).first()
            like.delete()
            return False
        else:
            like = self.like_set.create(user.user)
            return True
    
class Comment(models.Model):
    user =  models.ForeignKey(User, on_delete=models.CASCADE)
    image = models.ForeignKey(Image, on_delete=models.CASCADE)
    text = models.TextField(blank=False)
    pub_date = models.DateTimeField('Published at')
    approved = models.BooleanField(default=False) 
    def __str__(self):
        return f"{self.id}-{self.image.title[:15]}-{self.text}"

class Like(models.Model):
    user =  models.ForeignKey(User, on_delete=models.CASCADE)
    image = models.ForeignKey(Image, on_delete=models.CASCADE)

lab8/myimgur/images/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect
from .models import Image, Comment
from django.utils import timezone
from django.urls import reverse

# Create your views here.
def home(request):
    context = {}
    return render(request, 'images/home.html', context)

def index(request):
    images = Image.objects.all()
    context = {
        'image_list': images
    }
    return render(request, 'images/list.html', context)

def detail(request, image_id):
    image = get_object_or_404(Image, pk=image_id)
    comments = image.comment_set.all()
    context = {
        'image': image,
        'comments' : comments,
        'liked' : image.liked_by(request.user),
    }
    return render(request, 'images/detail.html', context)

def create_image(request):
    if request.method == "POST":
        title = request.POST['title']
        url = request.POST['url']
        pub_date = request.POST['pub_date']

        image = Image(title=title, url=url, pub_date=pub_date)
        image.save()
        return HttpResponseRedirect(reverse("app:detail", args=[image.id,]))

    return render(request, 'images/new.html')


def post_comment(request, image_id):
    if request.method == "POST" and request.user.is_authenticated:
        image = get_object_or_404(Image, pk=image_id)
        comment = Comment(text=request.POST['text'], user = request.user, image = image, pub_date=timezone.now())
        comment.save()

    return HttpResponseRedirect(reverse("app:detail", args=[image_id]))

def like(request, image_id):
    image = get_object_or_404(Image, pk=image_id)
    if request.user.is_authenticated and request.method == "POST":
        image.toggle_like(request.user)

    return HttpResponseRedirect(reverse("app:detail", args=(image.id,)))

lab8/myimgur/images/templates/images/base.html
{% load static %}
<html>
  <head>
    <title>My Lame Imgur</title>
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
      integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z"
      crossorigin="anonymous"
    />
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
      integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.bundle.min.js"
      integrity="sha384-LtrjvnR4Twt/qOuYxE721u19sVFLVSA4hf/rRt6PrZTmiPltdZcI7q7PXQBYTKyf"
      crossorigin="anonymous"
    ></script>

    <link rel="stylesheet" href="{% static 'app/css/app.css' %}" />
  </head>
  <body>
    <div class="page-header">
      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="navbar-brand" href="/">My Lame Imgur</a>
        <button
          class="navbar-toggler"
          type="button"
          data-toggle="collapse"
          data-target="#navbarSupportedContent"
          aria-controls="navbarSupportedContent"
          aria-expanded="false"
          aria-label="Toggle navigation"
        >
          <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
              <a class="nav-link" href="/"
                >Home <span class="sr-only">(current)</span></a
              >
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url 'app:create_image' %}"
                >Add new image</a>
            </li>
            {% if request.user.is_superuser %}
            <li class="nav-item">
              <a class="nav-link" href="/admin">Admin</a>
            </li>
            {% endif %}
          </ul>

          <ul class="navbar-nav ml-auto">
            <li class="nav-item">
              {% if request.user.is_authenticated %} User: {{ request.user.username }} {{ user.email }}
              <a class="nav-link" href="{% url 'logout' %}">Odjavi se</a>
              {% else %}
              <a class="nav-link" href="{% url 'login' %}">Prijavi se</a>
              {% endif %}
            </li>
          </ul>
        </div>
      </nav>
    </div>
    <div class="content container">
      <div class="row">
        <div class="col-md-12">
          <div class="jumbotron fluid-jumbotron">
            <div class="container">
              <h1 class="display-4">My Lame Imgur</h1>
              <p class="lead">
                Your one stop place for posting your lamest images!
              </p>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">{% block content %} {% endblock %}</div>
      </div>
    </div>
  </body>
</html>

lab8/myimgur/images/templates/images/detail.html
{% extends 'images/base.html' %}
{% block content %}

<div class"container">
    <div class="row">
        <div class="col-md-6">
            <h1>{{ image.title }}</h1>
            <form action="{% url 'app:like' image.id %}" method="post">
                {% csrf_token %}
                {% if liked %}
                <input type="submit" value="Like {{ image.like_set.count }}" class="btn btn-primary">
                {% else %}
                <input type="submit" value="Like {{ image.like_set.count }}" class="btn btn-secondary">
                {% endif %}
            </form>
            <div>
                <p>Objavljeno: {{ image.pub_date }}</p>
                <img src="{{ image.url }}" class="full-width">
            </div>
        </div>
        <div class="col-md-6">
            <h1>Komentari</h1> 
            {% for comment in comments %}
                <p class="comment">
                    <strong>{{comment.user.username}}</strong>
                    ( {{ comment.pub_date }} ) <br/>
                    {{ comment.text }}
                </p>
            {% endfor %}
            {% if user.is_authenticated %}
            <form action="{% url 'app:post_comment' image.id %} " method="post">
                {% csrf_token %}
                <p>
                    <label for="comment_text">Text</label>
                    <input id="comment_text" name="text" type="text">
                </p>

                <input type="submit">
            </form>
            {% else %}
            <p>Morate biti prijavljeni
                <a href="{% url 'login' %}">Prijavi se</a>
            </p>
            {% endif %}
        </div>     
    </div>
</div>

{% endblock %}

lab8/myimgur/images/templates/images/home.html
{% extends 'images/base.html' %}
{% block content %}
<h1>MyImgur</h1>
<p>Dobrodošli na naš imgur</p>

<p>
    <a href="{% url 'app:index' %}">Idi na sve slike</a>
</p>
{% endblock content %}

lab8/myimgur/images/templates/images/list.html
{% extends 'images/base.html' %}
{% block content %}
  <div>
    <h1>Dobrodošli na naš imgur</h1>
    <h2>Uživajte u slikama</h2>  
  </div>
  {% for image in image_list %}
      <div>
          <h3>Naziv: 
              <a href="{% url 'app:detail' image.id %}">
                  {{ image.title }}
              </a>
          </h3>
          <img src="{{ image.url }}" style="width:300px;">
          <p>Objavljeno: {{ image.pub_date }}</p>
        <hr>
      </div>
  {% endfor %}
{% endblock content %}

lab8/myimgur/images/templates/images/new.html
{% extends 'images/base.html' %}
{% block content %}

<div class"container">
  <div class="row">
    <div class="col-md-6">
      <form action="{% url 'app:create_image' %}" method="post">
        <div class="form-group">
          {% csrf_token %}
          <label for="title">Title</label>
          <input type="text" class="form-control" id="title" name="title">
          <label for="">URL</label>
          <input type="text" class="form-control" id="url" name="url">
          <label for="">Date</label>
          <input type="date" class="form-control" id="date" name="pub_date">
        </div>
        <button type="submit" class="btn btn-primary">Add Image</button>
    </div>
  </div>
</div>

{% endblock %}